



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于MySql全文索引</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于MySql全文索引</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 15:51:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>从 Mysql 4.0 开始就支持全文索引功能，但是 Mysql 默认的最小索引长度是 4。如果是英文默认值是比较合理的，但是中文绝大部分词都是2个字符，这就导致小于4个字的词都不能被索引，全文索引功能就形同虚设了。国内的空间商大部 分可能并没有注意到这个问题，没有修改 Mysql 的默认设置。</p>
<p>为什么要用全文索引呢？</p>
<p>一般的数据库搜索都是用的SQL的 like 语句，like 语句是不能利用索引的，每次查询都是从第一条遍历至最后一条，查询效率极其低下。一般数据超过10万或者在线人数过多,like查询都会导致数据库崩溃。 这也就是为什么很多程序都只提供标题搜索的原因了，因为如果搜索内容，那就更慢了，几万数据就跑不动了。</p>
<p>Mysql 全文索引是专门为了解决模糊查询提供的，可以对整篇文章预先按照词进行索引，搜索效率高，能够支持百万级的数据检索。</p>
<p>如果您使用的是自己的服务器，请马上进行设置，不要浪费了这个功能。</p>
<p>如果您使用的是虚拟主机，请马上联系空间商修改配置。首先，Mysql 的这个默认值对于中文来说就是一个错误的设置，修改设置等于纠正了错误。其次，这个配置修改很简单，也就是几分钟的事情，而且搜索效率提高也降低了空间商 数据库宕掉的几率。如果你把本篇文章发给空间商，我相信绝大部分都会愿意改的。</p>
<h4>设置方法：</h4>
<p>For 5.5</p>
<p># MySQL全文索引查询关键词最小长度限制</p>
<p>ft_min_word_len</p>
<p>影响索引的全文变量&nbsp;(ft_min_word_len、&nbsp;ft_max_word_len或ft_stopword_file),或假如你改 变了禁用词文件本身，则你必须在改变和重新启动服务器后重建你的&nbsp;FULLTEXT索引。这时，要重建索引， 只需进行一个QUICK&nbsp;修理操作：</p>
<h4><a href="http://www.ahlinux.com/mysql/" rel="external nofollow noreferrer">mysql</a>&gt;REPAIR TABLE&nbsp;tbl_name&nbsp;QUICK; &nbsp;#重建索引</h4>
<h4># MySQL全文索引查询关键词最小长度限制</h4>
<h4>For 5.6</h4>
<h4>innodb_ft_min_token_size</h4>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnnvzkq.html">CentOS桌面安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oo1l58.html">RabbitMQ 路由选择 &lpar;Routing&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3lr09.html">&lbrack;转&rsqb;基于四叉树（QuadTree）的LOD地形实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkrkr8.html">DLLImport</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1krg38.html">poj 1265 Area（Pick定理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm32g69.html">獲取 Textarea 的光標位置（摘自網絡）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge3mz78.html">Git一些其它的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj5drk9.html">spring&plus;mybatis之声明式事务管理初识&lpar;小实例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvgkg8.html">201521123087 《Java程序设计》第9周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4lx79.html">linkin大话java</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me046pq.html">Flask框架（1）--基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrpz59.html">java多线程（4）---volatile关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5nnvq.html">Python 写了个小程序，耗时一天，结果才100多行</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7on1ge8.html">Javascript中函数提升和变量提升</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j125k09.html">vue element-ui 的奇怪组件el-switch</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3ykk8.html">python之datetime类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwodx78.html">php函数addslashes&lpar;&rpar;使用方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyzp4n9.html">&lbrack;python&rsqb; 查找列表中重复的元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/963j4rn9.html">&lbrack;C&sol;C&plus;&plus;标准库&rsqb;&lowbar;&lbrack;初级&rsqb;&lowbar;&lbrack;转换UTC时间到local本地时间&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vzkozq.html">HGOI20181030 模拟题解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qnpgj28.html">初识Asp&period;net Identity</a>
			</li>
						<li><a href="https://www.batexi.com/a/3906knj9.html">MS10-046漏洞测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ezrpk8.html">&lbrack;转&rsqb; X-RIME&colon; 基于Hadoop的开源大规模社交网络分析工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/4952v4v9.html">ios  删除系统从相册压缩的视频</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq116m6q.html">JRebel for Android 1&period;0发布！</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kxg26q.html">Effective Java 46 Prefer for-each loops to traditional for loops</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2pzm38.html">oracle-删除归档日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93mzon8.html">asp&period;net的心得体会</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93mzr08.html">Ubuntu升级内核</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ezn4x8.html">c&plus;&plus; initialize&lowbar;list</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
